-- плоскость
-- сначала выполняется код в основном теле, а потом love.load()

function love.load(arg)
  if arg and arg[#arg] == "-debug" then require("mobdebug").start() end
  Graph=love.graphics
  ScreenW=800 -- размеры экрана
  ScreenH=600
  --love.window.setFullscreen(true, "desktop")
  --love.window.setMode( ScreenW, ScreenH, {fullscreen="desktop"} )
  IX=math.ceil(ScreenW/Dens/2) -- для отрисовки неподвижных объектов
  IY=math.ceil(ScreenH/Dens/2)
  -- w,h,f=love.window.getMode()
  -- print (w,h,f)
  L1=Graph.newCanvas(ScreenW,ScreenH) -- слои фона и для объектов
  L2=Graph.newCanvas(ScreenW,ScreenH)
  
  Star1=Graph.newImage("star1.png")
  Star2=Graph.newImage("star2.png")
  Star3=Graph.newImage("star3.png")
  Star4=Graph.newImage("star4.png")
  Stone0=Graph.newImage("stone.png")
  Stone1=Graph.newImage("stone1.png")
  Stone2=Graph.newImage("stone2.png")
  Stone3=Graph.newImage("stone0.png")
  Flash1=Graph.newImage("flash1.png")
  Flash2=Graph.newImage("flash2.png")
  Flash3=Graph.newImage("flash3.png")
  Flash4=Graph.newImage("flash4.png")
  Frame1=Graph.newImage("blocks/empty-frame1.png")
  Op_field=Graph.newImage("interface/op-field.png")
  Plate1=Graph.newImage("blocks/plate1.png")
  Grid1=Graph.newImage("blocks/octo-grid1.png")
  FlGrid1=Graph.newImage("blocks/octo-wf-grid1.png")
  FlGrid2=Graph.newImage("blocks/octo-wf-grid2.png")
  Block1=Graph.newImage("blocks/octo-tile1.png")
  Block2=Graph.newImage("blocks/octo-tile2.png")
  Circle_block1=Graph.newImage("blocks/circle-frame1.png")
  Circle_block2=Graph.newImage("blocks/circle-frame2.png")
  Sphere=Graph.newImage("blocks/sphere-frame.png")
  Grid2=Graph.newImage("blocks/octo-grid2.png")
  Core2=Graph.newImage("blocks/coil-core2.png")
  Core1=Graph.newImage("blocks/block-core2.png")
  Otile1=Graph.newImage("blocks/octo-tile1.png")
  Diamond2=Graph.newImage("blocks/diamond2.png")
  Turret_las=Graph.newImage("blocks/las-turret.png")
  Hero=Graph.newImage("hero1.png")
  Enemy=Graph.newImage("fighter1.png")
  Enemy2=Graph.newImage("fighter2.png")
  Enemy3=Graph.newImage("fighter3.png")
  Enemy4=Graph.newImage("fighter4.png")
  Enemy5=Graph.newImage("fighter5.png")
  Enemy6=Graph.newImage("fighter6.png")
  Enemy7=Graph.newImage("jammer1.png")
  Solar2=Graph.newImage("blocks/solar-panel2.png")
  Aim=Graph.newImage("interface/aim.png")
  love.mouse.setVisible(false)
  Frag1=Graph.newImage("fragments/fragment1.png")
  Frag2=Graph.newImage("fragments/fragment2.png")
  Frag3=Graph.newImage("fragments/fragment3.png")
  Frag4=Graph.newImage("fragments/fragment4.png")
  Frag5=Graph.newImage("fragments/fragment5.png")
  Frag6=Graph.newImage("fragments/fragment6.png")
  Frag7=Graph.newImage("fragments/fragment7.png")
  Frag8=Graph.newImage("fragments/fragment8.png")
  Frag9=Graph.newImage("fragments/fragment9.png")
  Missile=Graph.newImage("missile-f.png")
  My_missile=Graph.newImage("my-missile.png")
  Torpedo=Graph.newImage("torpedo.png")
  Bomb=Graph.newImage("bomb.png")
  Diode=Graph.newImage("interface/diode.png")
  Laser_sensor=Graph.newImage("interface/laser.png")
  Sun=Graph.newImage("sun1.png")
  My_target=nil
  T_armor=0
  T_energy=0
  Level_waves=4
  Level_wave_num=1
  Level_cores=0
  
  love.window.setMode(ScreenW,ScreenH) -- экран
  
  -- слои удобнее делать независимыми? 
  space1={} -- все неподвижные объекты, над которыми можно двигаться, находятся в этой таблице.
  -- поиск производится от текущего положения объекта игрока
  space2={} -- все подвижные мешающие объекты находятся в этой таблице.
  space3={} -- все двигающиеся объекты, вроде снарядов
  sand={}
  turrets={}
  --my_bullets={}
  
  stars={} -- фон
  
  -- условные координаты игрока
  X=ScreenW/2
  Y=ScreenH/2
  -- 
  Xa=0
  Ya=0
  --
  Game_on=true
  Pause=true
  --
  New_Level_starting=true
  --
  math.randomseed(3)
  --
  make_prototypes()
  make_enemies(Enemy_number)
  --make_enemies(1)
  --buildings()
  make_asteroids()
  make_trash()
  make_stars()
  space1_check()
  --print("Cores:",Level.cores)
  --for k,v in pairs(space1) do
    --print(k,v.xi,v.yi)
  --end
  Menu={Title={y=Y-200,text="GREEN ORBITS",choosen=1}, New={y=Y-100, text="New",choosen=2},Resume={y=Y,text="Resume",choosen=3},Quit={y=Y+100,text="Quit",choosen=4}}
  Choosen=0
  
end
-- трафарет (пока не надо)
local function myStencilFunction()
   love.graphics.rectangle("fill", 100, 200, 150, 250)
end

-- функции поведения

function moving(x,y,tx,ty,dt,aggr)
  if tx==nil or ty==nil then
   return 0
  end
  
  D=math.sqrt((tx-x)*(tx-x)+(ty-y)*(ty-y))
  if D>30 then
   return 10*aggr
  elseif D>20 then
    return 5*aggr
  elseif D>10 then
    return 3*aggr 
  elseif D>4 then
    
      return aggr
    
  else
    if aggr==nil then
      return 0
    else
      return aggr
    end
    
  end
  
  -- установить тягу по дистанции
  -- цель ближе определенной дистанции - уменьшить тягу
  -- скольжение
  -- вроде, все и так работает
end

function turning(x,y,tx,ty,beta,dt)
  if tx==nil or ty==nil then
    return 0
  end
  
  -- tx, ty -- индексные координаты цели
  -- поворачиваться на цель, пока угол не в пределах погрешности
  local dx, dy, A
  dx=tx-x
  dy=ty-y
  A=math.atan2(dy,dx)
  
  
   if A>beta+0.1 then
     return math.abs(A-beta)*dt*2
    --elseif A<0 and beta>0 then
      
      --return -math.abs(A-beta)*2*dt
    elseif A<beta-0.1 then 
      return -math.abs(A-beta)*dt*2
    else
      return 0
   end
 
 
end

function firing(obj,dt)
  local what, new_obj,ax,ay,D,bc
  if obj==nil then
    return
  end
  if obj.weapon_type==nil then
    return
  end
  what=obj.weapon_type
  -- проверить счетчик боезапаса и таймер
  if what.count<1 then
    return
  end
  if what.T<what.Tmax then
    obj.weapon_type.T=obj.weapon_type.T+dt
    return
  end
  -- сбросить таймер
  --print("T - Ok")
      
  -- создать объект луча, снаряда или ракеты с нужными параметрами
  if obj.weapon_type.I_am=="missile" then
   -- print("M!")
  -- ракета
   if obj.target==nil then
     return
   end
   --print("Yes")
   
   new_obj=full_copy(missile)
   new_obj.target=0
  -- new_obj.pic=Missile
   --new_obj.I_am="missile"
   new_obj.x=obj.x+2*math.cos(obj.phi)
   new_obj.y=obj.y+2*math.sin(obj.phi)
   --new_obj.armor=10
   new_obj.sx=(new_obj.x-player.x)*Dens+X
   new_obj.sy=(new_obj.y-player.y)*Dens+Y
   new_obj.speed_x=obj.speed_x*2
   new_obj.speed_y=obj.speed_y*2
   new_obj.phi=obj.phi
   if space2[#space2+1]==nil then
    space2[#space2+1]=new_obj
   end
   new_obj=nil
   --]]
  elseif what.I_am=="projectile" then
    if obj.target==0 then
      ax=player.x
      ay=player.y
    elseif obj.target~=nil and space2[obj.target]~=nil then
      ax=space2[obj.target].x
      ay=space2[obj.target].y
    else
      return
    end
     bc=(obj.x-ax)
     D=bc*bc
     bc=(obj.y-ay)
     bc=bc*bc
     D=D+bc
     if D<=81 then
       new_obj=full_copy(bullet)
       new_obj.target=0
  -- new_obj.pic=Missile
   --new_obj.I_am="missile"
       new_obj.x=obj.x+1.2*math.cos(obj.phi)
       new_obj.y=obj.y+1.2*math.sin(obj.phi)
   --new_obj.armor=10
       new_obj.sx=(new_obj.x-player.x)*Dens+X
       new_obj.sy=(new_obj.y-player.y)*Dens+Y
       new_obj.speed_x=obj.speed_x+15*math.cos(obj.phi) --+player.speed_x
       new_obj.speed_y=obj.speed_y+15*math.sin(obj.phi) --+player.speed_y
       if obj.pic==Enemy6 then
         new_obj.speed_x=new_obj.speed_x+player.speed_x
         new_obj.speed_y=new_obj.speed_y+player.speed_y
       end
     
       new_obj.energy=1
       new_obj.target=nil
       space3[#space3+1]=new_obj
       new_obj=nil
       
     end
     
     --print("P!")
    
  --
  elseif what.I_am=="bomb" then
   --print("B!")
      if obj.target==0 then
        --ax=player.x
        --ay=player.y
        return
      elseif obj.target~=nil and space2[obj.target]~=nil then
        ax=space2[obj.target].x
        ay=space2[obj.target].y
      else
       return
      end
     bc=(obj.x-ax)
     D=bc*bc
     bc=(obj.y-ay)
     bc=bc*bc
     D=D+bc
     if D>64 then
       return
     end
     
       new_obj=full_copy(bomb)
       new_obj.x=obj.x+1*math.cos(obj.phi)
       new_obj.y=obj.y+1*math.sin(obj.phi)
       new_obj.speed_x=obj.speed_x+2.2*math.cos(obj.phi)
       new_obj.speed_y=obj.speed_y+2.2*math.sin(obj.phi)
       --new_missile.spin=0
       new_obj.phi=obj.phi
       new_obj.target=nil
       new_obj.energy=2
       space3[#space3+1]=new_obj
       new_obj=nil
       --obj.weapon_type.T=0
  elseif what.I_am=="field" then
   if obj.target==0 then
        ax=player.x
        ay=player.y
        --return
      elseif obj.target~=nil and space2[obj.target]~=nil then
        ax=space2[obj.target].x
        ay=space2[obj.target].y
      else
       return
      end
     bc=(obj.x-ax)
     D=bc*bc
     bc=(obj.y-ay)
     bc=bc*bc
     D=D+bc
     if D>36 then
       return
     end 
     if obj.energy>obj.weapon_type.count then
      obj.energy=obj.energy-obj.weapon_type.count
      if obj.weapon_type.count<50 then 
       obj.energy=obj.energy-1
       obj.weapon_type.count=obj.weapon_type.count+1
      end
      -- воздействие
      JamP=JamP+10
      if obj.target==0 then
       player.energy=player.energy/2
       player.phi=player.phi+1
       player.speed_x=player.speed_x-obj.speed_x
       player.speed_y=player.speed_y-obj.speed_y
      elseif obj.target~=nil and space2[obj.target]~=nil then
        space2[obj.target].energy=space2[obj.target].energy/2
        space2[obj.target].phi=space2[obj.target].phi+1
        space2[obj.target].speed_x=space2[obj.target].speed_x-obj.speed_x
        space2[obj.target].speed_y=space2[obj.target].speed_y-obj.speed_y
      end
            
     else
       
          
       --obj.firing=false
      return
     end
     
  end
  obj.weapon_type.T=0
  obj.weapon_type.count=obj.weapon_type.count-1
  
  
  
end
-- лазер
function laser(x,y,r,alpha,obj)
 local cx, cy
 
 beam(x,y,r,alpha,obj)
 
 end

--
function selecting_weapon()
  -- проверить дистанцию
  -- выбрать вторичное
  -- проверить боезапас
  -- проверить соответствие цели
  -- нет? выбрать первичное
  -- проверить дистанцию
  -- решение (сближаться, стрелять)
end

function selecting_target(obj)
  -- выбрать цель по сценарию
  
  -- если целей много, то первую попавшуюся
end

function selecting_menace(obj)
  local k
 if obj.fiendly==true then
  k=obj.target
  k=k+1
  if k>#space2 then
   k=1
   
  end
  obj.target=k
 else
   -- турели не обстреливают подмогу?
 
 end
 

end

-- ------------------
-- прототипы объектов
function make_prototypes()
  player={pic=Hero, -- картинка
    phi=0, x=0, y=0, -- координаты, по сути - индекс в сетке
    w2=40, h2=40, -- ширина и высота спрайта
    r=30, -- для эффектов огня
    armor=100 ,energy=500, max_energy=700, -- так понятно
    firing=false, -- стреляет или нет
    speed_x=0,speed_y=0, -- компонентны скоростей
    sliding=false, -- скольжение
    radar_on=true, -- радар работает
    detected=false,
    on_ray=false,
    target=nil,
    weapon=1,
    weapon_type2={T=0,count=4,I_am="bomb",Tmax=4},
    weapon_type3={T=0,count=4,I_am="missile",Tmax=3},
    weapon_type4={T=0,count=20,I_am="projectile",Tmax=0.4},
  }
  -- враги и не только:
  
  enemy1={pic=Enemy, phi=math.pi , w2=40,h2=40, x=0,y=0,sx=0,sy=0, energy=200, armor=60, max_energy=500, speed_x=0,speed_y=0,turning=0, sliding=false, jumping=false, target=0,aggression=2,firing=false, I_am="ship",weapon_type={T=0,Tmax=3,count=4,I_am="bomb"} }
   enemy2={pic=Enemy2, phi=math.pi , w2=40,h2=40, x=0,y=0, sx=0,sy=0, energy=200, armor=40, max_energy=500, speed_x=0,speed_y=0,sliding=false, beta=0, aggression=3,firing=false, jumping=false, target=0, I_am="ship", weapon_type={T=0,Tmax=5,count=1,I_am="missile"}}
   enemy3={pic=Enemy3, phi=math.pi , w2=40,h2=40, x=0,y=0, sx=0,sy=0, energy=200, max_energy=500, speed_x=0,speed_y=0,sliding=false, beta=0, aggression=2,firing=false, armor=50, target=0, I_am="ship", weapon_type={T=0,count=200,I_am="projectile",Tmax=0.3}}
    enemy4={pic=Enemy4, phi=math.pi , w2=40,h2=40, x=0,y=0, sx=0,sy=0, energy=200, max_energy=500, speed_x=0,speed_y=0,sliding=false, beta=0, aggression=3,firing=false, armor=30, target=0, I_am="ship", weapon_type={T=0,count=2,I_am="missile",Tmax=8}}
    enemy5={pic=Enemy5, phi=math.pi , w2=40,h2=40, x=0,y=0, sx=0,sy=0, energy=200, max_energy=400, speed_x=0,speed_y=0,sliding=false, beta=0, aggression=2,firing=false, armor=70, target=0, I_am="ship", weapon_type={T=0,count=50,I_am="field",Tmax=0.8}}
    enemy6={pic=Enemy6, phi=math.pi , w2=40,h2=40, x=0,y=0, sx=0,sy=0, energy=200, max_energy=500, speed_x=0,speed_y=0,sliding=false, beta=0, aggression=1,firing=false, armor=40, target=0, I_am="ship",weapon_type={T=0,count=200,I_am="projectile",Tmax=0.4}}
    enemy7={pic=Enemy7, phi=math.pi , w2=40,h2=40, x=0,y=0, sx=0,sy=0, energy=200, max_energy=500, speed_x=0,speed_y=0,sliding=false, beta=0, aggression=1,firing=false, armor=30, target=0, I_am="ship"}
  -- частицы мусора:
  garbage={x=0,y=0,sx=0,sy=0}
  
  -- астероиды
  asteroid={ bg=Stone2, pic=Stone1, x=0,y=0,w2=40,h2=40,sx=0,sy=0,energy=100,max_energy=100,armor=500, pass_under=false}
  
  sand_asteroid={ pic=Stone0, bg=Stone3, x=0,y=0,w2=40,h2=40,sx=0,sy=0,energy=50,max_energy=50,armor=100, pass_under=false}
  
  -- ракета:
  missile={pic=Missile, phi=0,armor=10, energy=300, max_energy=300, x=0,y=0, sx=0,sy=0,sliding=false, beta=0,speed_x=40,speed_y=40, target=0, aggression=4, w2=20, h2=20, I_am="missile" }
  bullet={pic=Star2,armor=35,energy=1,x=0,y=0,sx=0,sy=0,speed_x=30,speed_y=30, phi=0, aggression=0,target=0, I_am="bullet",spin=0.1}
  torpedo={pic=Torpedo, phi=0,armor=10, energy=100, max_energy=300, x=0,y=0, sx=0,sy=0,sliding=false, beta=0,speed_x=40,speed_y=40, target=0, aggression=4, w2=20, h2=20, I_am="torpedo",spin=0 }
  bomb={pic=Bomb, phi=0,armor=10, energy=100, max_energy=300, x=0,y=0, sx=0,sy=0,sliding=false, beta=0,speed_x=40,speed_y=40, target=0, aggression=4, w2=20, h2=20, I_am="bomb",spin=-0.1 }
  
  -- оружие:
  missile_launcher={Tmax=3,count=4,I_am="missile",T=0}
  torpedo_launcher={Tmax=4,count=2,I_am="torpedo",T=0,spin=0}
  bomb_launcher={Tmax=4,count=4,I_am="bomb",T=0,spin=0}
  flak_cannon={Tmax=0.3, count=100,I_am="projectile",T=0}
  cannon={Tmax=0.3, count=100,I_am="projectile",T=0}
  
  -- луч:
  ray={energy=10,x=0,y=0,sx=0,sy=0}
  
  -- вспышка:
  blast={pic=Star1,phi=0, x=0,y=0,sx=0,sy=0,energy=150,armor=0,speed_x=0,speed_y=0,max_energy=150,w2=40,h2=40,aggression=0, I_am="blast"}
  -- sx, sy - экранные координаты 
 
  -- планета:
  planet={pic='', x=X+20, x=Y+20,D=140}
  --
  
  -- след
   spur={x=0,y=0, num=0}
  -- базовые структуры:
  -- добавить поле столкновений!
  base1={pic=Grid2, bg=Grid1, x=0,y=0,w2=40,h2=40,sx=0,sy=0,energy=100,max_energy=100,armor=100, pass_under=false}
  base2={pic=Core2,bg=Block1, x=0,y=0,w=40,h=40,sx=0,sy=0,energy=500,max_energy=1000, armor=500, pass_under=false}
  base3={pic=Core1,bg=Block1, x=0,y=0,w=40,h=40,sx=0,sy=0,energy=500,max_energy=1000, armor=500, pass_under=false}
  base_block2={pic=Diamond2, bg=Otile1, x=0,y=0,w=40,h=40,sx=0,sy=0,energy=100,max_energy=500, armor=400,  pass_under=false}
  base_block1={bg=Plate1,pic=Frame1,x=0,y=0,w2=40,h2=40,energy=100,sx=0,sy=0,max_energy=100,armor=200,pass_under=true}
  tank_block={pic=Circle_block2, bg=Circle_block1, x=0,y=0,w=40,h=40,sx=0,sy=0,energy=100,max_energy=100, armor=100,  pass_under=false}
  sphere_block={pic=Sphere, bg=Frame1, x=0,y=0,w=40,h=40,sx=0,sy=0,energy=100,max_energy=100, armor=100,  pass_under=false}
  
  -- оружие
  
  give_me_m={pic=Missile, bg=Frame1, x=0,y=0,w=40,h=40,sx=0,sy=0,energy=100,max_energy=500, armor=400,  pass_under=true, num=16}
  give_me_b={pic=Bomb, bg=Frame1, x=0,y=0,w=40,h=40,sx=0,sy=0,energy=100,max_energy=500, armor=400,  pass_under=true,num=16}
  give_me_f={pic=Star2, bg=Frame1, x=0,y=0,w=40,h=40,sx=0,sy=0,energy=100,max_energy=500, armor=400,  pass_under=true,num=600}
  --
  
  turret_block={pic=Turret_las,bg=Plate1, x=0,y=0,w=40,h=40,sx=0,sy=0,energy=500,max_energy=500, armor=400, pass_under=false, phi=0,firing=false,spin=2, I_am="turret", target=0,friendly=false}
  --
  Radar={xr=81, yr=513,r0=70,working=true} -- радар
  Ogrid2={pic=Grid2, bg=Grid1, x=0,y=0,w2=40,h2=40,sx=0,sy=0,energy=100,max_energy=100,armor=100,  pass_under=false}
  Ogrid1={pic=Grid1, x=0,y=0,w2=40,h2=40,sx=0,sy=0,energy=100,max_energy=100,armor=100,  pass_under=true}
  Solar_grid1={pic=Solar2, bg=Grid1, x=0,y=0,w2=40,h2=40,sx=0,sy=0,energy=100,max_energy=100,armor=100,  pass_under=false}
  -- структуры
  Dendro1={ {x=0,y=0,b=base2},{x=1,y=0,b=base_block2},{x=2,y=0,b=base_block2},
    {x=2,y=-1,b=base_block2},{x=2,y=1, b=base_block2},
    {x=3,y=0,b=turret_block},
    {x=1,y=-2,b=Ogrid2},
    {x=1,y=2,b=Ogrid2},
    {x=0,y=2,b=Ogrid2},
    {x=2,y=-3,b=Solar_grid1},
    {x=2,y=3,b=Ogrid1},  
    {x=3,y=-2,b=Ogrid1},
    {x=3,y=2,b=Ogrid1},
    {x=3,y=1,b=Ogrid1},
    {x=3,y=1,b=base_block2},
    {x=4,y=-2,b=Ogrid1},
    {x=4,y=2,b=Ogrid1},
  }
  Dendro2={ {x=0,y=0,b=base2},{x=0,y=1,b=base_block2},
    {x=1,y=2,b=base_block2},
    {x=1,y=-2,b=base_block2},
    {x=1,y=0,b=base_block2},
    {x=2,y=2,b=Ogrid2},
    {x=2,y=3,b=Ogrid2},
    {x=2,y=-2,b=Ogrid2},
    {x=2,y=-3,b=Ogrid2},
    {x=3,y=2,b=Ogrid2},
    {x=3,y=-2,b=Ogrid1},
    {x=4,y=3,b=Ogrid1},  
    {x=4,y=-3,b=Ogrid2},
    {x=0,y=1,b=Ogrid2},
    {x=0,y=-1,b=Ogrid2},
  }
  
  turret_struct={{x=0,y=0,b=turret_block},
     {x=2,y=1,b=Solar_grid1},
     {x=2,y=-1,b=Solar_grid1},
     {x=1,y=0,b=base_block2}
    }
  
  Small_struct={{x=0,y=0,b=base_block2},
    {x=1,y=0,b=Ogrid2},
    {x=1,y=1,b=Solar_grid1},
    {x=1,y=2,b=Solar_grid1},
    {x=2,y=1,b=Solar_grid1},
    {x=1,y=-1,b=Solar_grid1},
    {x=1,y=-2,b=Solar_grid1},
    {x=2,y=-1,b=Solar_grid1},
  }
  Mine_struct={{x=0,y=0,b=asteroid},
    {x=0,y=1,b=base_block2},
    {x=0,y=-1,b=base_block2},
    {x=0,y=2,b=Ogrid1},
    {x=0,y=-2,b=Ogrid1},
    {x=1,y=2,b=base_block2},
    {x=2,y=2,b=Solar_grid1},
    {x=2,y=-2, b=Solar_grid1},
    {x=1,y=3,b=Solar_grid1},
    {x=1,y=-3,b=Solar_grid1},
    {x=1,y=0,b=tank_block},
  }
  
  Long_struct={{x=0,y=0,b=base2},
    {x=0,y=1,b=base_block2},
    {x=1,y=1,b=Ogrid1},
    {x=2,y=1,b=Ogrid1},
    {x=3,y=1,b=Ogrid1},
    {x=4,y=1,b=Ogrid1},
    {x=5,y=1,b=Ogrid1},
    {x=6,y=1,b=Ogrid1},
    {x=6,y=0,b=tank_block},
    {x=0,y=-1,b=base_block2},
    {x=1,y=-1,b=Ogrid1},
    {x=2,y=-1,b=Ogrid1},
    {x=3,y=-1,b=Ogrid1},
    {x=4,y=-1,b=Ogrid1},
    {x=5,y=-1,b=Ogrid1},
    {x=6,y=-1,b=Ogrid1},
    --{x=6,y=0,b=tank_block},
    }
  
  My_base={{x=0,y=0,b=base3},
    {x=0,y=-1,b=base_block2},
    {x=1,y=0,b=Ogrid1},
    {x=1,y=-1,b=sphere_block},
    {x=1,y=1,b=sphere_block},
    {x=2,y=2,b=base_block2},
    {x=2,y=3,b=base_block2},
    {x=2,y=4,b=base_block2},
    {x=3,y=3,b=turret_block},
    {x=0,y=-3,b=give_me_b},
    {x=0,y=-4,b=Ogrid1},
    {x=0,y=-5,b=give_me_m},
    {x=0,y=-6,b=Ogrid1},
    {x=0,y=-7,b=give_me_f},
    {x=0,y=-8,b=Ogrid1},
    {x=0,y=-2,b=base_block1},
    {x=0,y=3,b=base_block1},
    {x=0,y=4,b=Ogrid1},
     {x=0,y=5,b=Ogrid1},
     {x=0,y=6,b=base_block2},
     {x=0,y=2,b=base_block2},
    }
    
    Enemy_base={{x=0,y=0,b=base2},{x=1,y=0,b=base_block2},
      {x=1,y=1,b=base_block2},
      {x=1,y=-1,b=base_block2},
      {x=1,y=3,b=turret_block},
      {x=3,y=-3,b=turret_block},
      {x=1,y=-2,b=Ogrid2},
      {x=1,y=2,b=Ogrid2},
      {x=0,y=-1,b=tank_block},
      {x=0,y=-2,b=base_block2},
      {x=0,y=-3,b=base2},
      {x=0,y=-4,b=Ogrid1},
      {x=1,y=-4,b=Ogrid1},
      {x=2,y=-4,b=Ogrid1},
      {x=3,y=-5,b=Solar_grid1},
      {x=0,y=1,b=Ogrid2},
      {x=0,y=2,b=base_block2},
      }
  
  star={pic=Star1,x=10,y=10,sx=10,sy=10,k=1}
  --player.weapon_type=flak_cannon
end

-- полное копирование для прототипов
function full_copy(t)
  if type(t)~="table" then
    return t
  else
    local T={}
    for k,v in pairs(t) do
      T[k]=full_copy(v)
    end
--    setmetatable(T,t) --- не надо?

    return T
  end
end
-- конец копирования


--создаем мусор
function make_trash()
 local i,T
 for i=1,4 do
   T=full_copy(garbage)
   T.sx=math.random()*800
   T.sy=math.random()*600
   sand[i]=T
   T=nil
  end 
end

-- создаем врагов
function make_enemies(n)
  local i, mark,Enemy_type,c1,coin
  c1=0
  
  for i=1,n do
    coin=math.random()
    if coin>0.85 then
    Enemy_type=missile
  elseif coin>0.7 then
    Enemy_type=enemy1
    c1=c1+1
  elseif coin>0.6 then
   Enemy_type=enemy2
  elseif coin>0.5 then
   Enemy_type=enemy3
  elseif coin>0.4 then
   Enemy_type=enemy4
  elseif coin>0.3 then
   Enemy_type=enemy7
  elseif coin>0.2 then
   Enemy_type=enemy6 
  else
    Enemy_type=enemy5
  end
    
    NewEnemy=full_copy(Enemy_type)
   -- print('NewEnemy:',NewEnemy)
    NewEnemy['x']=i+math.ceil(50*(math.random()-0.5))+120
    NewEnemy['y']=i+math.ceil(50*(math.random()-0.5))+10
    NewEnemy.sx=i*Dens
    NewEnemy.sy=i*Dens
    --NewEnemy.aggression=
    mark=tostring(i)..":"..tostring(i)
    space2[i]=NewEnemy
    NewEnemy=nil
  end
  
  if c1>0 then
  NewEnemy=full_copy(missile)
   NewEnemy['x']=(n+1)+math.ceil(100*(math.random()-0.5))+20
    NewEnemy['y']=(n+1)+math.ceil(100*(math.random()-0.5))+20
    NewEnemy.sx=(n+1)*Dens
    NewEnemy.sy=(n+1)*Dens
    mark=tostring(n+1)..":"..tostring(n+1)
    space2[n+1]=NewEnemy
    NewEnemy=nil
  end
end
-- генератор уровня

-- генератор астероидов

function make_asteroids()
 local ax,ay, start_x,start_y,end_x,end_y, Ast_dens, L, obj, O, Key
 start_x=-300+math.floor(math.random()*200)
 start_y=-100+math.floor(math.random()*40)
 Ast_dens=60+math.floor(math.random()*50)
 end_x=math.abs(start_x)
 end_y=start_y+Ast_dens*1.5
 L=math.floor((end_x-start_x)/Ast_dens)
 for y=start_y,end_y,Ast_dens/4 do
   for x=start_x,end_x,Ast_dens do
    if x>-100 and x<100 then
    --
     O=true
    elseif O==true then
      O=false
    -- 
    elseif O==false then
     O=true
    end
    
    if O==true then
      if math.random()<0.1 then
       obj=full_copy(give_me_f)
      elseif math.random()<0.2 then
       obj=full_copy(give_me_m)
      elseif math.random()<0.4 then
       obj=full_copy(sand_asteroid)
      else
       obj=full_copy(asteroid)
      end
   
     obj.x=x+math.floor(math.random()*50)
     obj.y=y+math.floor(math.random()*50)
     Key=tostring(math.floor(obj.x))..":"..tostring(math.floor(obj.y))
     --obj.sx=obj.x*Dens
     --obj.sy=obj.y*Dens
     space1[Key]=obj
     --obj=nil
    end
  
   end
 end
 
 
end


-- конструкции
function struct_generator(x,y,n)
 local Key, dx,dy, m, ddx,ddy, q, k,v,D, coin,piece1,piece2,M
 m=n-1
 
 if n==1 then
   D=Dendro1
 elseif n==2 then
   D=Dendro2
  elseif n==3 then
    D=My_base
  elseif n==4 then
    D=Mine_struct
  elseif n==5 then
    D=Long_struct
  elseif n==6 then
    D={{x=0,y=0,b=base2},{x=0,y=1,b=base_block2},{x=0,y=-1,b=base_block2},}
    if math.random()>=0.5 then
     M=4
    else
      M=3
    end
    
    for i=1,M do
      coin=math.random()
     if coin>0.3 then
       piece1={x=1,y=i,b=Ogrid1}
       piece2={x=1,y=-i,b=Ogrid1}
      elseif coin>0.5 then
        piece1={x=i,y=i,b=Ogrid1}
        piece2={x=i,y=-i,b=Ogrid1} 
      elseif coin>0.7 then
        piece1={x=2,y=i,b=Ogrid1}
        piece2={x=2,y=-i,b=Ogrid1}
      elseif coin>0.8 then
        piece1={x=0,y=i,b=turret_block}
        piece2={x=0,y=-i,b=turret_block}  
      else
        piece1={x=i,y=1,b=Ogrid2}
        piece2={x=i,y=-1,b=Ogrid2}
      
     end
     D[#D+1]=piece1
     D[#D+1]=piece2
     piece1=nil
     piece2=nil
     
    end
  elseif n==7 then
    D=turret_struct
    
  elseif n==8 then
    D=Small_struct
  elseif n==9 then
    D=Enemy_base
  else
    D=Small_struct
  end
  
 
 for k,v in pairs(D) do
    
    ddx=v.x
    ddy=v.y
    q=v.b
 
   Key=tostring(math.floor(x+ddx))..":"..tostring(math.floor(y+ddy))
   if space1[Key]~=nil or n==0 then
     goto next_struct
   end
  
   NewBlock=full_copy(q)
   NewBlock["x"]=x+ddx
   NewBlock["y"]=y+ddy
   NewBlock["sx"]= NewBlock.x*Dens
   NewBlock["sy"]= NewBlock.y*Dens
   
   
   if q==turret_block then
     
    turrets[Key]=NewBlock
    if n==3 then
      turrets[Key].friendly=true
      turrets[Key].target=1
    end
    
   end
   space1[Key]=NewBlock
   
   NewBlock=nil
  ::next_struct::
 end
 for k,v in pairs(D) do
    
    ddx=-v.x
    ddy=v.y
    q=v.b
 
   Key=tostring(math.floor(x+ddx))..":"..tostring(math.floor(y+ddy))
   if space1[Key]~=nil or n==0 then
     goto next_struct
   end
  
   NewBlock=full_copy(q)
   NewBlock["x"]=x+ddx
   NewBlock["y"]=y+ddy
   NewBlock["sx"]= NewBlock.x*Dens
   NewBlock["sy"]= NewBlock.y*Dens
   
   
   if q==turret_block then
    turrets[Key]=NewBlock
    if n==3 then
      turrets[Key].friendly=true
      turrets[Key].target=1
    end
   end
   space1[Key]=NewBlock
   NewBlock=nil
  ::next_struct::
 end 
  
 
end
 
 -- большая штука
function big_segment()
local x,y,Key,R,start,stop,a,step,i,bl
a=math.random()

 if a>0.8 then
  start=0
  stop=pi2
 elseif a>0.5 then
  start=pi2
  stop=math.pi
 else
  start=math.pi
  stop=math.pi*3/2
 end
 step=pi2/8
 --a=math.random()
 R=5
 for i=2,6,1  do
   a=math.random()
   
   for k=start,stop,step do
    if a>0.8 then
     bl=full_copy(base1)
    elseif a>0.6 then
      bl=full_copy(base_block2)
    elseif a>0.4 then
      bl=full_copy(Ogrid2)
    elseif a>0.2 then
       bl=full_copy(tank_block)
    else
       bl=full_copy(Solar_grid1)
    end
    x=math.floor(R*i*math.cos(k))
    y=math.floor(R*i*math.sin(k))
    bl.x=x
    bl.y=y
    Key=tostring(x)..":"..tostring(y)
    space1[Key]=bl
    bl=nil
    
    a=math.random()
    if a>0.6 then
     y=y+1
    elseif a>0.4 then
      x=x-1
    else
      x=x+1
      y=y-1
    end
    bl=full_copy(Ogrid1)
    bl.x=x
    bl.y=y
    Key=tostring(x)..":"..tostring(y)
    space1[Key]=bl
    bl=nil
    
   end
 end




end

--проверка ядер
function space1_check()
local N
 N=0
 for k,v in pairs(space1) do
   if v.pic==Core2 then
     N=N+1
     --print("C",v.x,v.y, tostring(v.pic))
   end
   
 end
 --print("Cores:",N)
Level_cores=N

end

function buildings()
  
  local x,y
  x=math.floor(math.random()*500-250)
  y=math.floor(math.random()*400-200)
  struct_generator(x,y,1)
  x=math.floor(math.random()*500-250)
  y=math.floor(math.random()*400-200)
  struct_generator(x,y,5)
  struct_generator(50,-25,3)
  x=math.floor(math.random()*100-50)
  y=math.floor(math.random()*100-50)
  struct_generator(x,y,6)
  x=math.floor(math.random()*50+20)
  y=math.floor(math.random()*50+20)
  struct_generator(x,y,2)
  x=math.floor(math.random()*20-30)
  y=math.floor(math.random()*20-30)
  struct_generator(x,y,4)
  
  
end

-- Всякая всячина:

N=0 -- не помню
xb=300
dx=1
Angle=0 -- угол игрока
My_target_angle=0
Show_help=false

SinA=0 -- sin и cos, чтоб не вычислять одно и то же два раза
CosA=1 
--
-- xr=81 -- центр экрана локатора
-- yr=513
-- r0=70
Enemy_number=4
New_wave=false
JamY=0 -- положение помехи на экране
JamP=0 -- ее мощность

scr_step=40 -- шаг по экрану
pi2=math.pi/2
Trottle_zero=10
Field={} -- все двигающиеся объекты, попавшие в поле видимости.
-- 
Dens=40 -- плотность объектов на экране.
D2=Dens/2
Cmax=300 -- максимальная координата
Pause=true -- пауза для меню
Ready=false -- готовность ракет

--
Stage={T=1,Label="Stage ",num=1}
--stars={}
--уровень
--Level_waves=4
--Level_wave_num=1
--Level_cores=0
Beams={}

--make_asteroids()
--make_enemies(Enemy_number)
--new_game()
-- -------
function make_stars()
 local obj, star_pic, s
 for k=1,20 do
   obj=full_copy(star)
   obj.k=math.random()*0.3+0.1
   obj.x=math.random()*3200-1600
   obj.y=math.random()*590+5
   
   s=math.random()
   if s>0.7 then
    obj.pic=Star1
   elseif s>0.5 then
    obj.pic=Star2
   elseif s>0.3 then
    obj.pic=Star3
   else
    obj.pic=Star4 
   end
   if k==1 then
    obj.pic=Sun
    --obj.x=1400
    obj.k=1
    obj.y=Y
   end
   
   stars[k]=obj
   --obj=nil
 end
 
end

--

function love.keyreleased(key)
  -- in v0.9.2 and earlier space is represented by the actual space character ' ', so check for both
  if key=="escape" then 
    if Pause==false then
      
      Pause=true
    elseif Show_help==false then
      Pause=false
    else 
      Show_help=false
    end  
        
  end
  
  
end

function love.wheelmoved(wheel_x,wheel_y)
  if wheel_y>0 then
    player.weapon=player.weapon+1
    if player.weapon>4 then
      player.weapon=1
    end
  elseif wheel_y<0 then
    player.weapon=player.weapon-1
    if player.weapon<1 then
      player.weapon=4
    end
  end
  
end

-- луч
function beam(x1,y1,r, phi, obj)
  
  local xi,yi,xc,yc,Key,P, Explosion, fragment
  
  if r<2 or r>10 then
    return
  end
  
  -- Beams={}
  xi=x1
  yi=y1
  P=0
  xi=x1+r*math.cos(phi)
  yi=y1+r*math.sin(phi)
  xc=math.floor(xi)
  yc=math.floor(yi)
  Key=tostring(xc)..":"..tostring(yc)
  --if space1[Key]==nil then
    if Beams[Key]~=nil then
      Beams[Key]=Beams[Key]+2
    else
      Beams[Key]=2
    end
  

   xi=x1+(r+1)*math.cos(phi)
  yi=y1+(r+1)*math.sin(phi)
  xc=math.floor(xi)
  yc=math.floor(yi)
  Key=tostring(xc)..":"..tostring(yc)
  if Beams[Key]~=nil then
    Beams[Key]=Beams[Key]+2
  else
    Beams[Key]=2
  end
  
   xi=x1+(r-1)*math.cos(phi)
  yi=y1+(r-1)*math.sin(phi)
  xc=math.floor(xi)
  yc=math.floor(yi)
  Key=tostring(xc)..":"..tostring(yc)
  if Beams[Key]~=nil then
    Beams[Key]=Beams[Key]+2
  else
    Beams[Key]=2
  end
  
  end 
 

-- огонь
function fire()
 local fx,fy,m,R,Key, speckle, fragment
 if player.energy<4 then
   return
 else
   player.energy=player.energy-2
 end
  
 fx=X+player.r*CosA-0
 fy=Y+player.r*SinA-0
 --Graph.circle("fill",fx,fy,10)
 m=math.random()
 Graph.draw(Flash1,fx,fy,0,0.7+m,0.7+m,15,15)
 R=(mX-X)*(mX-X)+(mY-Y)*(mY-Y)
  
 fx=(mX-X)/Dens
 fy=(mY-Y)/Dens
 if math.abs(fx)+math.abs(fy)<1.5 then
   return
 end
 
 fx=player.x+fx
 fy=player.y+fy
 fx=math.floor(fx)
 fy=math.floor(fy)
 Key=tostring(fx)..":"..tostring(fy)

 
 Beams[Key]=2
 R=math.sqrt(R)/Dens
 beam(player.x,player.y,R,Angle-pi2,player)
 if space1[Key]~=nil then
  if space1[Key].armor~=nil then
    speckle=full_copy(blast)
    speckle.x=space1[Key].x
    speckle.y=space1[Key].y
    speckle.sx=(speckle.x-player.x)*Dens+X+Dens/2
    speckle.sy=(speckle.y-player.y)*Dens+Y+Dens/2
    space2[#space2+1]=speckle
    space1[Key].armor=space1[Key].armor-1
    if space1[Key].armor<0 then
      for c=1,3 do
       dVx=math.random()*10-5
       dVy=math.random()*10-5
       fragment=full_copy(bullet)
       fragment.energy=3
       fragment.x=space1[Key].x
       fragment.y=space1[Key].y
       if c==1 then
        fragment.pic=Frag1
       elseif c==2 then
         fragment.pic=Frag5
       elseif c==3 then
         fragment.pic=Frag7
        
       end 
       
       fragment.speed_x=dVx
       fragment.speed_y=dVy
       space3[#space3+1]=fragment
       fragment=nil
      end
      space1[Key]=nil
      
    end
       
    
  end
  
 end
 
end


function weapon_use()
  local what,R,t,nb,Key
  -- what=player.weapon_type
  if player.weapon==1 then
   fire()
   
  end
  if player.weapon==3 and player.weapon_type3.count>0 then
      if player.target==nil then
        return
      end
      
      if player.weapon_type3.T>=player.weapon_type3.Tmax then
       player.weapon_type3.count=player.weapon_type3.count-1
       nb=full_copy(missile)
       nb.x=player.x +1*CosA
       nb.y=player.y +1*SinA
       nb.speed_x=player.speed_x
       nb.speed_y=player.speed_y
       nb.phi=Angle
       nb.pic=My_missile
       nb.target=player.target
       space2[#space2+1]=nb
       nb=nil
       player.weapon_type3.T=0
     
      else
       player.weapon_type3.T=player.weapon_type3.T+0.1
      end
    
  elseif player.weapon==2 and player.weapon_type2.count>0 then
    --if what.count>0 then
      if player.weapon_type2.T>=player.weapon_type2.Tmax then
       player.weapon_type2.count=player.weapon_type2.count-1
       nb=full_copy(bomb)
       nb.x=player.x+1.2*math.cos(Angle-pi2)
       nb.y=player.y+1.2*math.sin(Angle-pi2)
      -- new_obj.x=obj.x+1.2*
       --new_obj.y=obj.y+1.2*
   
       nb.sx=(nb.x-player.x)*Dens+X
       nb.sy=(nb.y-player.y)*Dens+Y
       nb.speed_x=player.speed_x+2*CosA
       nb.speed_y=player.speed_y+2*SinA
       --new_missile.spin=0
       nb.target=-1
       nb.phi=Angle
       --nb.target=nil
       space3[#space3+1]=nb
       nb=nil
       player.weapon_type2.T=0
     
      else
       player.weapon_type2.T=player.weapon_type2.T+0.1
      end
    --end
  elseif player.weapon==4 and player.weapon_type4.count>0 then
    --if what.count>0 then
      if player.weapon_type4.T>=player.weapon_type4.Tmax then
       player.weapon_type4.count=player.weapon_type4.count-1
       nb=full_copy(bullet)
       nb.target=-1
       nb.x=player.x+1.1*math.cos(Angle-pi2)
       nb.y=player.y+1.1*math.sin(Angle-pi2)
       -- проблема столкновений
       
       
       nb.speed_x=player.speed_x+15*CosA
       nb.speed_y=player.speed_y+15*SinA
       --Key=tostring(math.floor(nb.x))..":"..tostring(math.floor(nb.y))
       --Beams[Key]=nil
       R=math.sqrt((mX-X)*(mX-X)+(mY-Y)*(mY-Y))
       nb.energy=R/500 -- как-то связать с dt
       --new_missile.spin=0
       nb.phi=Angle
       --nb.target=nil
       space3[#space3+1]=nb
       nb=nil
       player.weapon_type4.T=0
     
      else
       player.weapon_type4.T=player.weapon_type4.T+0.1
      end
    --end
  end
  

end


-- двигаем песок
function move_sand()
 local i,x0,y0
 for i=1,4 do
   x0=sand[i].sx
   y0=sand[i].sy
   x0=x0-player.speed_x*1.5
   y0=y0-player.speed_y*1.5
   if x0<0 then
     x0=math.random()*ScreenW/2+ScreenW/2
   end
   if x0>ScreenW then
     x0=math.random()*ScreenW/2
   end
   if y0<0 then
     y0=math.random()*ScreenH/2+ScreenH/2
   end
   if y0>ScreenH then
     y0=math.random()*ScreenH/2
   end
   sand[i].sx=x0
   sand[i].sy=y0
 end
end

-- двигаем врагов
function move_enemies(dt)
  local k,v, Key, cx,cy, V1, V2, speckle,sled,gamma,V3,Key_p,D,ax,ay,Aim,beta, fragment, dVx,dVy, aim_key
  --ax=obj.x
  --ay=obj.y
  for k,v in pairs(space2) do
    Aim=v.target
    if v.target==nil and v.I_am~="blast" then 
      --print("1)")
      if v.I_am=="missile" then
       if v.armor>0 then
         --print(v.target)
        v.armor=v.armor-0.1
       else
         v.I_am="blast"
         v.pic=Star2
         v.armor=0
       end
      end
      goto next
    elseif v.target~=0 and space2[Aim]~=nil and v.I_am~="blast" then
      --print("2)")
      ax=space2[Aim].x
      ay=space2[Aim].y
      
      if ax==nil or ay==nil then
        if v.I_am=="missile" then
          if v.armor>0 then
            v.armor=v.armor-1
          else
            v.I_am="blast"
            v.pic=Star2
            v.armor=0
          end
        end
        goto next
      end
      
    elseif Aim==0 then
      --print("3)")
      ax=player.x
      ay=player.y
      if v.I_am=="missile" then
        player.detected=true
      end
      
    end
    
    --ax=player.x
    --ay=player.y
    
    v.x=v.x+v.speed_x/Dens
    v.y=v.y+v.speed_y/Dens
    --
    if v.sliding==false then
     v.sx=(v.x-player.x)*Dens+X+Dens --+ math.random()-0.5
     v.sy=(v.y-player.y)*Dens+Y+Dens -- +math.random()-0.5
    else
     local sx1,sy1
     sx1=(v.sx+(v.x-player.x)*Dens+X+Dens)/2
     sy1=(v.sy+(v.y-player.y)*Dens+Y+Dens)/2
     v.sx=sx1
     v.sy=sy1
     if math.abs((v.x-player.x)*Dens+X+Dens-v.sx)<=Dens and math.abs((v.y-player.y)*Dens+Y+Dens-v.sy)<=Dens then
      v.sliding=false
     end
          
    end
    
    
    
    --
    beta=math.atan2(v.y-player.y,v.x-player.x)
    if math.abs(beta-Angle+pi2)<0.2 then
      My_target=v.pic
      T_armor=v.armor
      T_energy=v.energy
      My_target_angle=v.phi
      player.target=k
    end
    
    if player.firing==true and player.energy>2 and player.weapon==1 then
      if mX>=v.sx-v.w2 and mX<v.sx+Dens and mY>=v.sy-v.h2 and mY<v.sy+Dens and v.armor>0 then  --and (v.I_am=="ship" or v.I_am=="missile")
        v.armor=v.armor-4
        --
        speckle=full_copy(blast)
        speckle.x=v.x
        speckle.y=v.y
        speckle.sx=v.sx --Dens-Dens
        speckle.sy=v.sy --Dens-Dens-Dens
        speckle.speed_x=v.speed_x
        speckle.speed_y=v.speed_y
        space2[#space2+1]=speckle
        --
        if v.armor<1 then
          
         v.pic=Flash1
         v.I_am="blast"
         for c=1,4 do
           dVx=math.random()*10-5
           dVy=math.random()*10-5
           fragment=full_copy(bullet)
           fragment.energy=3
           fragment.x=v.x
           fragment.y=v.y
           if c==1 then
             fragment.pic=Frag3
           elseif c==2 then
              fragment.pic=Frag4
           elseif c==3 then
             fragment.pic=Frag5
           else
              fragment.pic=Frag6
           end 
       
              fragment.speed_x=v.speed_x+dVx
             fragment.speed_y=v.speed_y+dVy
            space3[#space3+1]=fragment
            fragment=nil
          end
         
        end
        
      end
      
    end
    -- конец секции со стрельбой
    
   
    if v.phi==nil then
     v.phi=0
    end
    
    gamma=turning(v.x,v.y, ax,ay, v.phi,dt)
    v.phi=v.phi+gamma
    if gamma<0.05 and gamma>-0.05 then
      V3=moving(v.x,v.y,ax,ay,dt,v.aggression)
      if math.abs(v.speed_x)>10*v.aggression then
        v.speed_x=v.speed_x*0.8
        
      elseif v.energy>1 then
        v.speed_x=v.speed_x+V3*math.cos(v.phi)*dt
        v.energy=v.energy-0.1
      end
      if math.abs(v.speed_y)>10*v.aggression then
        v.speed_y=v.speed_y*0.8
      elseif v.energy>1 then
       v.speed_y=v.speed_y+V3*math.sin(v.phi)*dt
       v.energy=v.energy-0.1
      end
      --
      if v.target~=nil and v.weapon_type~=nil and v.I_am=="ship" then
        --print("W")
       firing(v,dt)
      end
      --
      if ax~=nil and ay~=nil and math.abs(v.x-ax)<5 and math.abs(v.y-ay)<5 and v.energy>4 and v.armor>3 and v.I_am~="missile" then
        D=(v.x-ax)*(v.x-ax)+(v.y-ay)*(v.y-ay)
        D=math.sqrt(D)
        laser(v.x,v.y,D,v.phi,v)
        v.energy=v.energy-2
        v.firing=true
        player.on_ray=true
      
        
      end
     
            
    else 
      v.speed_x=v.speed_x*0.95
      v.speed_y=v.speed_y*0.95
       
    end
    
    
    
    if v.pic==Enemy7 then
       if math.abs(v.x-player.x)<9 and math.abs(v.y-player.y)<9 then
         JamP=18-math.abs(v.x-player.x)-math.abs(v.y-player.y)+JamP
         player.detected=true
       end
       
      end
    
    cx=math.floor(space2[k].x) -- было floor
    cy=math.floor(space2[k].y)
    -- столкновение с игроком
    -- надо будет продумать столкновение с другими объектами
    if v.sx>X-20 and v.sx<X+20 and v.sy>Y-20 and v.sy<Y+20 and v.I_am=="ship" then
       
             
        Angle=Angle+math.random()-0.5
        V1=-0.5*(player.speed_x+v.speed_x)
        V2=-0.5*(player.speed_y+v.speed_y)
        player.speed_x=V1
        v.speed_x=-V1
        player.x=player.x+V1/Dens
        player.y=player.y+V2/Dens
        v.x=v.x-V1/Dens
        v.y=v.y-V2/Dens
        player.speed_y=V2
        v.speed_y=-V2
        player.energy=player.energy*0.8
        v.energy=v.energy*0.8
      
     

     
     if V1>=0 then
       player.x=player.x+0.5
       v.x=v.x-0.5
      else
        player.x=player.x-0.5
       v.x=v.x+0.5
     end
     if V2>=0 then
       player.y=player.y+0.5
       v.y=v.y-0.5
      else
        player.y=player.y-0.5
       v.y=v.y+0.5
     end
     
    end
    --
    
    Key=tostring(cx)..":"..tostring(cy)
    
        
    if Beams[Key]~=nil then
     v.armor=v.armor-Beams[Key]
     speckle=full_copy(blast)
     speckle.x=v.x
     speckle.y=v.y
     speckle.sx=v.sx --Dens-Dens
     speckle.sy=v.sy --Dens-Dens-Dens
     speckle.speed_x=v.speed_x
     speckle.speed_y=v.speed_y
     space2[#space2+1]=speckle
     Beams[Key]=nil
     if v.armor<1 and (v.I_am=="ship" or v.I_am=="missile") then
       v.I_am="blast"
      v.pic=Flash2
      v.armor=0
      for c=1,4 do
       dVx=math.random()*10-5
       dVy=math.random()*10-5
       fragment=full_copy(bullet)
       fragment.energy=3
       fragment.x=v.x
       fragment.y=v.y
       if c==1 then
        fragment.pic=Frag1
       elseif c==2 then
         fragment.pic=Frag2
       elseif c==3 then
         fragment.pic=Frag3
        else
          fragment.pic=Frag4
       end 
       
       fragment.speed_x=v.speed_x+dVx
       fragment.speed_y=v.speed_y+dVy
       space3[#space3+1]=fragment
       fragment=nil
      end
     
     end
     
    end
    --]]
    
    if v.armor>2 and v.energy<v.max_energy and v.I_am=="ship" then
      v.energy=v.energy+0.5
    end
    if v.I_am=="missile" then
     --aim_key=v.target
     if v.target==nil or (space2[v.target]==nil and v.target~=0) then
      v.armor=0
      v.I_am="blast"
      v.pic=Star2
      v.aggression=0
     end
     
    end
    
    
    if ax~=nil and ay~=nil and v.x<=ax+1 and v.x>=ax-2 and v.y<=ay+1 and v.y>=ay-2 and v.I_am=="missile" then
      speckle=full_copy(blast)
     speckle.x=v.x
     speckle.y=v.y
     speckle.sx=v.sx --Dens-Dens
     speckle.sy=v.sy
     space2[#space2+1]=speckle
     v.armor=0
     v.I_am="blast"
     v.pic=Flash2
     v.aggression=0
     if Aim~=nil and Aim~=0 and space2[Aim]~=nil then
       space2[Aim].energy=space2[Aim].energy-400 --свои ракеты сильнее?
       if space2[Aim].energy<0 then
         space2[Aim].armor=space2[Aim].armor+space2[Aim].energy
       end
       -- print("Shot!")
     elseif Aim==0 then
       player.energy=player.energy-200
       if player.energy<0 then
         player.armor=player.armor+player.energy
         player.energy=0
       end
     end
     
     
     goto next
    end
    
   
    
    if space1[Key]==nil and space2[k]~=nil and space2[k].armor>0 then
      sled=full_copy(spur)
      sled.x=v.x
      sled.y=v.y
      sled.num=k
      space1[Key]=sled
      sled=nil
    end
     if space1[Key]~=nil and space1[Key].num~=k and space1[Key].pass_under~=true and space1[Key].energy~=nil then
       if v.I_am=="missile" then
        v.I_am="blast"
        v.pic=Flash2
        v.armor=0
        v.x=0
        v.y=0
        -- добавить пвреждение структур
        space1[Key].energy=space1[Key].energy-200
        if space1[Key].energy<0 then
          space1[Key].armor=space1[Key].armor+space1[Key].energy
        end
        if space1[Key].armor<=0 then
          space1[Key]=nil
          --
          space1_check()
        end
                
       elseif v.I_am=="ship" then
         
         v.x=v.x-v.speed_x/Dens
      
         v.y=v.y-v.speed_y/Dens
         v.phi=v.phi+math.random()*2-1
         local dx,dy,Rj
         Rj=math.ceil(math.random()*5+1)
         dx=math.floor(v.x+Rj*math.cos(v.phi))
         dy=math.floor(v.y+Rj*math.sin(v.phi))
         Key=tostring(dx)..":"..tostring(dy)
         if space1[Key]==nil then
           v.x=dx
           v.y=dy
           v.sliding=true
           v.speed_x=0
           v.speed_y=0
         end
         
      
      
       end
     end
  ::next::      
  end
  --Beams={}
  
end
-- --------------------------
-- двигаем турели
function move_turrets(dt)
 local D, ind
 for k,v in pairs(turrets) do
  v.phi=v.phi+v.spin*dt
  if v.phi>2*math.pi then
    v.phi=0
  elseif v.phi<0 then 
    v.phi=2*math.pi
  end
  if v.target==0 and v.friendly==false then
   if math.abs(player.x-v.x)<8 and math.abs(player.y-v.y)<8 and v.energy>2 then
     if math.abs(turning(v.x,v.y, player.x,player.y, v.phi,dt))<0.05 then
      D=(v.x-player.x)*(v.x-player.x)+(v.y-player.y)*(v.y-player.y)
      D=math.sqrt(D)
      laser(v.x,v.y,D,v.phi,v)
      v.energy=v.energy-2
      v.firing=true
      player.on_ray=true
     end
    
    elseif v.energy<v.max_energy then
      v.energy=v.energy+dt+dt
      v.firing=false
      
   end
  elseif v.target~=nil and space2[v.target]~=nil and space2[v.target].I_am~="blast"  then
    
    ind=v.target
    if math.abs(space2[ind].x-v.x)<8 and math.abs(space2[ind].y-v.y)<8 and v.energy>2 then
     if math.abs(turning(v.x,v.y, space2[ind].x,space2[ind].y, v.phi,dt))<0.05 then
      D=(v.x-space2[ind].x)*(v.x-space2[ind].x)+(v.y-space2[ind].y)*(v.y-space2[ind].y)
      D=math.sqrt(D)
      laser(v.x,v.y,D,v.phi,v)
      v.energy=v.energy-2
      v.firing=true
      -- player.on_ray=true
     end
     
    else
      
      if v.energy<v.max_energy then
       v.energy=v.energy+dt+dt
       v.firing=false
      end
      -- поменять цель из space2, т.к. далеко
      selecting_menace(v)
    
    end
  else
     selecting_menace(v)
    -- поменять цель из space2, т.к. нет
  end
  
 
 end
 
end

-- снаряды
function move_bullets(dt)
  local cx,cy,Key,S1,E,speckle -- Key1, Key2,Key3
  for k,v in pairs(space3) do
   v.x=v.x+v.speed_x/Dens
   v.y=v.y+v.speed_y/Dens
   v.energy=v.energy-dt
   v.sx=(v.x-player.x)*Dens+X
   v.sy=(v.y-player.y)*Dens+Y
   --v.target~=-1 -- чтоб не попадать по самому себе
   if v.sx>X-Dens and v.sx<X+Dens and v.sy>Y-Dens and v.sy>Y+Dens/2 and v.target~=-1 then
     if player.energy>v.armor and player.energy>1 then
      player.energy=player.energy-20
      
     else
      player.armor=player.armor-15
      
     end
     if v.I_am~="bomb" then
       v.energy=0
     end
      
     
   end
   
   cx=math.floor(v.x)
   cy=math.floor(v.y)
   Key=tostring(cx)..":"..tostring(cy)
   --Key1=tostring(cx-1)..":"..tostring(cy-1)
  -- Key2=tostring(cx-1)..":"..tostring(cy)
  -- Key1=tostring(cx)..":"..tostring(cy-1)
   if v.energy<=0 then
     if v.I_am=="bullet" then --projectile
       
      
       if Beams[Key]~=nil then
        Beams[Key]=Beams[Key]+v.armor
       else
         Beams[Key]=v.armor
       end
               
        
     end
    space3[k]=nil
    goto end_cycle
   elseif v.energy<=0.08 then
     if v.I_am=="bullet" then --projectile
       
       if Beams[Key]~=nil then
        Beams[Key]=Beams[Key]+v.armor
       else
         Beams[Key]=v.armor
       end
       
       --[[
       if Beams[Key1]~=nil then
        Beams[Key1]=Beams[Key1]+v.armor
       else
         Beams[Key1]=v.armor
       end
       if Beams[Key2]~=nil then
        Beams[Key2]=Beams[Key2]+v.armor
       else
         Beams[Key2]=v.armor
       end
        if Beams[Key3]~=nil then
        Beams[Key3]=Beams[Key3]+v.armor
       else
         Beams[Key3]=v.armor
       end
        --]]
     end
     space3[k].pic=Flash4
   end
   
   if Beams[Key]~=nil then
    Beams[Key]=Beams[Key]+v.armor
   else
    Beams[Key]=v.armor
   end
   if space1[Key]~=nil then
    -- S1=space1[Key]
    if space1[Key].energy~=nil then
     
     if v.I_am=="bomb" then
       E=1000
        speckle=full_copy(blast)
        speckle.x=v.x
        speckle.y=v.y
        speckle.sx=v.sx --Dens-Dens
        speckle.sy=v.sy
        
        speckle.pic=Flash2
        
        space2[#space2+1]=speckle
     
       shockwave(cx,cy,1)
     else
       E= v.armor
     
     space1[Key].energy=space1[Key].energy-E
     
      if space1[Key].energy<=0 and space1[Key].armor~=nil then
       space1[Key].armor=space1[Key].armor+space1[Key].energy
       space1[Key].energy=0
         if space1[Key].armor<=0 then
           if space1[Key].pic==Core1 or space1[Key].pic==Core2 then
             speckle=full_copy(blast)
             speckle.x=space1[Key].x
             speckle.y=space1[Key].y
             speckle.sx=space1[Key].sx --Dens-Dens
             speckle.sy=space1[Key].sy
        
             speckle.pic=Flash3
        
             space2[#space2+1]=speckle
             shockwave(cx,cy,4)
             
           end
           
           space1[Key]=nil
           space1_check()
         end
       
      end
     end
     space3[k]=nil
     --goto end_cycle
    end
    
   end
      
   ::end_cycle::
 end
 
end

function move_stars(dt)
  for k,v in pairs(stars) do
   v.x=v.x+dt+dt
   if v.x>1600 then 
     v.x=-1600
   end
   
  end
  
end
-- рисуем снаряды
function draw_bullets()
  -- local
  for k,v in pairs(space3) do
    if v.sx>0 and v.sx<800 and v.sy>0 and v.sy<600 then
      --if v.energy<0.5 then
        --Graph.draw(v.pic,v.sx,v.sy,v.phi,v.energy,v.energy,15,15)
      --else
        Graph.draw(v.pic,v.sx,v.sy,v.phi,0.5,0.5,15,15)
      --end
    
      if v.phi>6.28 then
        v.phi=0
      elseif v.phi<0 then
        v.phi=6.26
      end
      v.phi=v.phi+v.spin
    end
   
  end
  
end


-- смотрим фоновые объекты
function draw_buildings()
 local mark,Ix1,Ix2,Iy1,Iy2,kx,ky, obj, cx,cy, px,py,fx,fy,Key
 
 Ix1=math.ceil(player.x-IX)
 Ix2=math.ceil(player.x+IX)
 Iy1=math.ceil(player.y-IY)
 Iy2=math.ceil(player.y+IY)
 
 for ky=Iy1,Iy2 do
   for kx=Ix1,Ix2 do
     px=2
     py=2
     mark=tostring(kx)..":"..tostring(ky)
     if space1[mark]~=nil then
       -- Graph.circle("fill",200,200,5)
       obj=space1[mark]
       cx=(obj.x-player.x)*Dens+X-10
       cy=(obj.y-player.y)*Dens+Y-10
       if obj.bg~=nil then
        Graph.draw(obj.bg,cx,cy,0,0.55,0.55)
        
       end
       
       
       if cx<X  then
         if cx<300 then px=-2 end
         if cx<100 then px=-3 end
       end
       if cx>X  then
         if cx>500 then px=2 end
         if cx>700 then px=3 end
       end
             
       if cy<Y  then 
         if cy<300 then py=-1 end
         if cy<100 then py=-2 end
       end
        
       if cy>Y  then 
         if cy>400 then py=2 end
         if cy>500 then py=4 end
         
       end
       
       
       if obj.pic~=nil then
        if obj.I_am~=nil and obj.I_am=="turret" then
          Graph.draw(obj.pic,cx+py+obj.w/2-2,cy+py+obj.h/2-2,obj.phi+pi2,0.55,0.55,obj.w,obj.h)
           if obj.firing==true then
              m=math.random()
              fx=cx+30*math.cos(obj.phi)+obj.w/2
              fy=cy+30*math.sin(obj.phi)+obj.h/2
              if cx>0 and cx<ScreenW and cy>0-Dens and cy<ScreenH then
                  Graph.draw(Flash1,fx,fy,0,0.7+m,0.7+m,15,15)
              end
        
              obj.firing=false
            end
          
        else
          Graph.draw(obj.pic,cx+px,cy+py,0,0.55,0.55)
          if obj.armor<50 then
            space1[mark].pic=nil
          end
          
        end
        --
        if obj.bg~=nil then
          if mX>cx-Dens and mX<cx+Dens and mY>cy-Dens and mY<cy+Dens and player.firing==true and player.weapon==1 and player.energy>2 then
            obj.armor=obj.armor-1
            Graph.draw(Star1,cx+px,cy+py,0,0.55,0.55)
            if obj.armor<1 then
             if obj.pic==Core2 or obj.pic==Core1 then
              nuclear_blast(cx,cy,30)
              shockwave(kx,ky,3)
              space1_check()
             end
             
            end
            
          end
          
        end
        
       
       end
      if obj.pic~=nil and obj.num~=nil then
       Graph.print(tostring(obj.num),cx+D2,cy+D2)
      end
      
     end
     
   end
 end
 --
 
 --
end
-- рисуем звезды
function draw_stars()
 for k,v in pairs(stars) do
  if v.x>0 and v.x<800 then
   Graph.draw(v.pic,v.x,v.y,0,v.k,v.k)
  end
  
 end
 
end

-- рисуем врагов
function draw_enemies()
  local k,v, koef,m,fx,fy,n
  n=0
  for k,v in pairs(space2) do
    
     if v.sliging==true then
       koef=1
     else
       koef=0.6
     end
     
     if v.armor<1 and v.I_am=="blast" then
       
       
       koef=v.energy/v.max_energy
       v.energy=v.energy*0.9
        if v.sx>0 and v.sx<ScreenW and v.sy>0-Dens and v.sy<ScreenH then
          Graph.draw(v.pic,v.sx,v.sy,v.phi,koef,koef,v.w2,v.h2)
        end
       
       
     else
       if v.sx>0 and v.sx<ScreenW and v.sy>0-Dens and v.sy<ScreenH then
         Graph.draw(v.pic,v.sx,v.sy,v.phi+pi2,koef,koef,v.w2,v.h2)
       end
       
       if v.firing==true then
       m=math.random()
       fx=v.sx+30*math.cos(v.phi)
       fy=v.sy+30*math.sin(v.phi)
        if v.sx>0 and v.sx<ScreenW and v.sy>0-Dens and v.sy<ScreenH then
          Graph.draw(Flash1,fx,fy,0,0.7+m,0.7+m,15,15)
        end
        
       v.firing=false
       end
      
       if v.weapon_type~=nil and v.weapon_type.T==0 and v.weapon_type.I_am=="field" then
         magnet_field(v.x,v.y,v.phi,v.energy)
       end
       
     
     
      if block_collision(v) then
        
        if v.I_am=="ship" then
         magnet_field(v.x,v.y,v.phi,v.energy)
         v.x=v.x-v.speed_x/20+math.random()*10-5
         v.y=v.y-v.speed_y/20+math.random()*10-5
         v.speed_x= -0.8*v.speed_x
         v.speed_y= -0.8*v.speed_y
         v.energy=0.8*v.energy
         if v.energy<2 then
           v.armor=v.armor-(math.abs(v.speed_x)+math.abs(v.speed_y))/10
         end
        elseif v.I_am=="missile" then
          v.I_am="blast"
          v.speed_x=0
          v.speed_y=0
          v.armor=0
          -- копия вспышки?
        end
        
      end
       
   
   end
   
   
    
    if v.energy<2 and (v.I_am~="ship" or v.I_am~="missile") then
      
       space2[k]=nil
    end
    n=n+1
  end
  --Graph.print(tostring(n),400,50)
  if n==0 then
    New_wave=true
  end
  --yy=0
  
end

-- рисуем песок
function draw_sand()
  local i
  for i=1,4 do
    Graph.points(sand[i].sx,sand[i].sy)
  end
end

-- проверка статуса игрока
function check_player_stat()
 local xc,yc,k,v,Key
 xc=math.floor(player.x)
 yc=math.floor(player.y)
 Key=tostring(xc)..":"..tostring(yc)
 for k,v in pairs(Beams) do
  if k==Key then
    player.armor=player.armor-1.5
    speckle=full_copy(blast)
     speckle.x=player.x
     speckle.y=player.y
     speckle.sx=X --Dens-Dens
     speckle.sy=Y --Dens-Dens-Dens
     speckle.speed_x=player.speed_x
     speckle.speed_y=player.speed_y
     speckle.armor=0
     space2[#space2+1]=speckle
     speckle=nil
     Beams[Key]=nil
  end
  
 end
 
end

-- установка скорости
function set_trottle(dmx,dmy,dt)

 
 local Vx, Vy,R2, ax,ay, dV, JamC -- , oVx, oVy
 
 if player.sliding==false and player.energy>2 then
 dV=0.2
 
 ax=dmx/ScreenH
 ay=dmy/ScreenH
 R2=dmx*dmx+dmy*dmy
 --oVx=player.speed_x
 --oVy=player.speed_y
 
 if R2<200 then
   Vx=0
   Vy=0
   dV=0
   player.speed_x=player.speed_x*0.9
   player.speed_y=player.speed_y*0.9
 else
   Vx=ax*5000*dt
   Vy=ay*5000*dt
 end
 
 
 
 if Vx*Vx>900 then
   if dmx>0 then
     Vx=30
    else
      Vx=-30
    end
 end
 
 
 if Vy*Vy>900 then
   if dmy>0 then
     Vy=30
   else 
     Vy=-30
    end
 end
  
  
  if Vx<0 then
    if player.speed_x<Vx then
     player.speed_x=player.speed_x+dV
    else
      player.speed_x=player.speed_x-dV
    end
    
  end
  
  if Vx>0 then
    if player.speed_x<Vx then
      player.speed_x=player.speed_x+dV
    else
       player.speed_x=player.speed_x-dV
    end
  end
  
  if Vy<0 then
   if player.speed_y<Vy then
     player.speed_y=player.speed_y+dV
    else
      player.speed_y=player.speed_y-dV
    end
  end
  if Vy>0 then
    if player.speed_y<Vy then
      player.speed_y=player.speed_y+dV
    else
      player.speed_y=player.speed_y-dV
    end
  end
 
 
   if math.abs(Vx-player.speed_x)+math.abs(Vy-player.speed_y)>1.5 then
      player.energy=player.energy-0.5
   end
  end
  
   Xa=player.speed_x
   Ya=player.speed_y
   player.x=player.x+player.speed_x/Dens
   player.y=player.y+player.speed_y/Dens
   
   JamC=math.floor(math.abs(player.x/Cmax)+math.abs(player.y/Cmax))
   JamP=JamC
  
end

-- изменение всего
function love.update(dt)
  local dmx,dmy,what,max_enemies
  
  -- здесь графика не работает
  --xb=xb+dx
  --if xb>700 then 
  --  dx=-1
  -- elseif xb<50 then
  --  dx=1
  -- end
  mX,mY=love.mouse.getPosition() -- координаты мыши
  dmx=mX-X
  dmy=mY-Y
  if Stage.T>0 then
   Stage.T=Stage.T-dt
  end
  
  
  Angle=math.atan2(dmy,dmx)+pi2
  SinA=math.sin(Angle-pi2)
  CosA=math.cos(Angle-pi2)
  
  if Game_on==false or Pause==true then
    --
    if love.mouse.isDown(1) and Pause==true then
      if Choosen==1 then
        Show_help=true --
       --print("What?")
       --Choosen=0
      elseif Choosen==2 then
        --print("New")
        
       Choosen=0
       Pause=false
       Game_on=true
       player.firing=false
       love.timer.sleep(0.2)
       --new_game()
       --make_enemies(m)
       New_wave=false
       player.x=0
       player.y=0
       player.speed_x=0
       player.speed_y=0
       player.energy=500
       player.armor=100
       player.weapon_type2.count=4
       player.weapon_type3.count=4
       player.weapon_type4.count=20
       Stage.num=1
       Stage.T=1
       space1={}
       make_asteroids()
       space2={}
       make_enemies(4)
       Beams={}
       space3={}
       JamP=0
       -- надо будет удалить
       --return
      elseif Choosen==3 then
        --print("Resume")
       Choosen=0
       Pause=false
       player.firing=false
       love.timer.sleep(0.2)
      elseif Choosen==4 then
        os.exit(true)
        --print("Quit")
       -- Choosen=0
      end
     
    else
      player['firing']=false
    end
    return
  end
  
  
  
  if love.mouse.isDown(1) and Game_on==true then
    player['firing']=true
  else
    player['firing']=false
  end
  
  
  if love.mouse.isDown(2) and Game_on==true then
    player['sliding']=false
  else
    player['sliding']=true
  end
  
  if player.weapon_type2.T<=player.weapon_type2.Tmax then
    player.weapon_type2.T=player.weapon_type2.T+dt
  end
  if player.weapon_type3.T<=player.weapon_type3.Tmax then
    player.weapon_type3.T=player.weapon_type3.T+dt
  end
  if player.weapon_type4.T<=player.weapon_type4.Tmax then
    player.weapon_type4.T=player.weapon_type4.T+dt
  end
  
  --if Game_on==false then return end
  
  set_trottle(dmx,dmy,dt)
  move_stars(dt)
  move_bullets(dt)
  move_enemies(dt)
  move_turrets(dt)
  
  check_player_stat()
  Beams={}
  move_sand()
  if player.energy<player.max_energy then
   player.energy=player.energy+0.2
  end
  if New_wave==true then
    space2={}
    
    -- здесь надо проверку на второе условие 
    if Level_wave_num<=Level_waves then
      Level_wave_num=Level_wave_num+1
      
      max_enemies=math.ceil(math.random()*Enemy_number+1)
      make_enemies(max_enemies)
    else
      space1_check()
      if Level_cores==0 then
        space1={}
      new_game()
      end
      
    end
    New_wave=false
    
  end
  
  
  if player.armor<=0 then Game_on=false end
  
end

-- рисуем меню
function draw_menu()
  local k,v,r,g,b,a -- menu_point
  Choosen=0
  for k,v in pairs(Menu) do
    r,g,b,a=Graph.getColor()
    -- print(type(v.y))
    if mX>190 and mX<340 and mY>v.y and mY<v.y+20 then
      Graph.setColor(0.1,0.9,0.1,0.5)
      Graph.rectangle( "fill", 190, v.y, 150, 20, 5, 2 )
      Choosen=v.choosen
      Graph.setColor(r,g,b,a)
      --return
    else
      Graph.setColor(0.4,0.8,0.4,0.5)
      Graph.rectangle( "fill", 190, v.y, 150, 20, 5, 2 )
      --Choosen=0
    end
    
    Graph.print(Choosen,100,100)
    Graph.setColor(r,g,b,a)
    Graph.print(v.text,200,v.y)
  end
  
end
--принудительное удаление
function deleting1()
for k,v in pairs(space1) do
 if v.pic==Core1 or v.pic==Core2 then
   v.pic=nil
   space1[k].pic=nil
   print(k)
 end
 
 space1[k]=nil
end
Level_cores=0
end

function deleting2()
for k,v in pairs(space2) do
 space2[k]=nil
end

end

  
-- пункты меню
function new_game()
local m, a
m=math.floor(math.random()*Enemy_number)+1
a=math.random()


Game_on=true
Pause=false
--space1={}
deleting1()
deleting2()
space2={}
space3={}
space1_check()
Level_wave_num=0
Level_waves=0
JamP=0
Level_cores=0

a=math.random()
if a>=0.8 then
  make_asteroids()
  for i=1,8 do
   x=math.floor(math.random()*200-100)
   y=math.floor(math.random()*200-100)
   if i<5 then
    struct_generator(x,y,7)
   else
    struct_generator(x,y,8)
   end
  
  end
  

  Level_wave_num=1
  Level_waves=2
elseif a>0.7 then
  make_asteroids()
   x=math.floor(math.random()*100+100)
   y=math.floor(math.random()*100+100)
  struct_generator(x,y,9)
   x=math.floor(math.random()*50-55)
   y=math.floor(math.random()*50-55)
  struct_generator(x,y,3)
  Level_wave_num=1
  Level_waves=3
  
elseif a>0.6 then
   make_asteroids()
   for i=1,6 do
   x=math.floor(math.random()*200-100)
   y=math.floor(math.random()*200-100)
   if i<5 then
    struct_generator(x,y,4)
   else
    struct_generator(x,y,8)
   end
  
   end
   x=math.floor(math.random()*200-100)
   y=math.floor(math.random()*200-100)
   struct_generator(x,y,2)
   Level_wave_num=1
   Level_waves=4

elseif a>0.4 then
  big_segment()
  local x,y
  x=math.floor(math.random()*100-50)
  y=math.floor(math.random()*100-50)
  struct_generator(x,y,3)
  Level_wave_num=1
  Level_waves=4
  --make_asteroids()
elseif a>0.2 then
  local x,y
  for i=1,6 do
   x=math.floor(math.random()*200-100)
   y=math.floor(math.random()*200-100)
   struct_generator(x,y,5)
  end
   x=math.floor(math.random()*200-100)
   y=math.floor(math.random()*200-100)
  struct_generator(x,y,3)
  Level_wave_num=1
  Level_waves=2
elseif a>0.1 then
  local x,y
  for i=1,4 do
   x=math.floor(math.random()*30+10)
   y=math.floor(math.random()*30+10)
   struct_generator(x,y,1)
  end
  for i=1,4 do
   x=math.floor(math.random()*25+30)
   y=math.floor(math.random()*25+30)
   struct_generator(x,y,2)
  end
  x=math.floor(math.random()*25-30)
   y=math.floor(math.random()*25-30)
   struct_generator(x,y,3)
  Level_wave_num=1
  Level_waves=3
else
  buildings()
  Level_wave_num=1
  Level_waves=5
  --make_asteroids()
end

space1_check()
make_enemies(m)
New_wave=false
player.x=0
player.y=0
player.speed_x=0
player.speed_y=0
player.energy=500
player.armor=100
player.weapon_type2.count=4
player.weapon_type3.count=4
player.weapon_type4.count=20
Stage.num=Stage.num+1
Stage.T=1

end


-- рисуем задник
function do_background()
  local r,g,b,a,cs
  r,g,b,a=Graph.getColor()
  Graph.setCanvas(L1) -- установить холст чтоб рисовать
  Graph.clear()
  --love.graphics.setColor(0,0,0)
  --Graph.rectangle("fill",0,0,600,400)
  cs=math.abs(stars[1].x)/2100
  
  love.graphics.setColor(cs+0.1,cs+0.1 , 0)
  love.graphics.circle("fill",700-player.x/80, 300, 150)
  love.graphics.setColor(r,g,b,a)
end

function do_foreground()
  -- love.graphics.setColor(10,255,55)
 if N==0 then 
  
   love.graphics.setCanvas(L2)
   Graph.draw(Op_field,0,0)
   --love.graphics.circle("line",300,300,300)
   
   N=1
  end
end 

-- эффекты
function jamming()
  local i,yJ
 if JamP>0 then
  for i=1,JamP do
    yJ=math.random()*JamP*8-4
   Graph.line(0,JamY+yJ,ScreenW,JamY+yJ)
  end
 else
  return
 end
 -- Graph.line(0,JamY,ScreenW,JamY)
 JamY=JamY+1
 if JamY>ScreenH then
   JamY=-100
 end
 
end

-- радар
function radar()
local x1,y1,k,v,a1,r1,n,nx,ny, signX, signY


x1=Radar.r0*CosA+Radar.xr
y1=Radar.r0*SinA+Radar.yr
Graph.line(Radar.xr,Radar.yr,x1,y1)
for k,v in pairs(space1) do
 
    

  x1=v.x-player.x
  y1=v.y-player.y
  if x1>=0 then 
    signX=1
   else 
    signX=-1
  end
  if  y1>=0 then 
    signY=1
   else 
    signY=-1
  end
  
  if x1*x1+y1*y1>=Radar.r0*Radar.r0 then
   a1=math.atan2(x1,y1)+pi2
   x1=0.95*Radar.r0*math.abs(math.cos(a1)) *signX
   y1=0.95*Radar.r0*math.abs(math.sin(a1)) *signY
   end
  x1=x1+Radar.xr
  y1=y1+Radar.yr
  Graph.points(x1,y1)
  if v.pic==Core1 or v.pic==Core2 then
    Graph.circle("line",x1,y1,1)
  end
  
  if v.pic==nil then
   space1[k]=nil
  end
  
  
end

end

-- поля
function magnet_field(xm,ym,alpha,Hm)
local xs,ys,rx,ry,hm,i
xs=(xm-player.x)*Dens+X
ys=(ym-player.y)*Dens+Y
if Hm<500 then hm=Hm/100
else
  hm=5
end

rx=2*hm*math.cos(alpha)
ry=2*hm*math.sin(alpha)
--stx=rx/4
--sty=ry/4
for i=5,0,-1 do
 Graph.circle("line",xs+rx*i,ys+ry*i,2*i*i)
 Graph.circle("line",xs-rx*i,ys-ry*i,2*i*i)
end

end
-- бабах


-- - вспышка
function nuclear_blast(x,y,P)
  local R,G,B,A,p
  
  R,G,B,A=Graph.getColor()
  Graph.setColor(200,255,200,200)
  if P>70 then
    r=70
  elseif P<0 then
    r=0
  else 
    r=P
  end
  
  Graph.circle("fill",x,y,r)
  Graph.setColor(R,G,B,A)
  player.detected=true
  
end
-- зона разрушений
function shockwave(xi,yi,n)
  
 local x,y,X1,X2,Y1,Y2, Key,m,nblast
 if n>3 then
   m=3
  else
    m=math.abs(n)
  end
  
 X1=xi-m
 X2=xi+m
 Y1=yi-m
 Y2=yi+m
 for y=Y1,Y2 do
   for x=X1,X2 do
     Key=tostring(x)..":"..tostring(y)
     if y==Y1 or y==Y2 then
      if x~=X1 and x~=X2 then
        
         if space1[Key]~=nil and space1[Key].pic~=nil and (space1[Key].pic==Core1 or space1[Key].pic==Core2) then
           nblast=full_copy(blast)
           nblast.x=x
           nblast.y=y
           nblast.sx=(space1[Key].x-player.x)*Dens+X 
           nblast.sy=(space1[Key].y-player.y)*Dens+Y
           nblast.pic=Flash3
           space2[#space2+1]=nblast
           space1[Key]=nil
           turrets[Key]=nil
           shockwave(x,y,5)
           space1_check()
          
         elseif space1[Key]~=nil and space1[Key].pic~=nil then
           nblast=full_copy(bullet)
           nblast.x=x
           nblast.y=y
           nblast.speed_x=x-X1-m
           nblast.speed_y=y-Y1-m
           nblast.sx=(space1[Key].x-player.x)*Dens+X 
           nblast.sy=(space1[Key].y-player.y)*Dens+Y
           if space1[Key].pic==Grid1 or space1[Key].pic==Grid2 then
             nblast.pic=Frag8
           elseif space1[Key].bg==Stone1 then
             nblast.pic=Stone1
           else
             nblast.pic=Frag9
           end
         
           space3[#space3+1]=nblast
           space1[Key]=nil
           turrets[Key]=nil
        
         end
          Beams[Key]=100
          space1[Key]=nil
          turrets[Key]=nil
         
       
      end
     else
         if space1[Key]~=nil and space1[Key].pic~=nil and (space1[Key].pic==Core1 or space1[Key].pic==Core2) then
           nblast=full_copy(blast)
           nblast.x=x
           nblast.y=y
          
           nblast.sx=(space1[Key].x-player.x)*Dens+X 
           nblast.sy=(space1[Key].y-player.y)*Dens+Y
           nblast.pic=Flash3
           space2[#space2+1]=nblast
           player.detected=true
           space1[Key]=nil
           turrets[Key]=nil
           shockwave(x,y,5)
           space1_check()
         elseif space1[Key]~=nil and space1[Key].pic~=nil  then
           nblast=full_copy(bullet)
           nblast.x=x
           nblast.y=y
            nblast.speed_x=x-X1-m
           nblast.speed_y=y-Y1-m
           nblast.sx=(space1[Key].x-player.x)*Dens+X 
           nblast.sy=(space1[Key].y-player.y)*Dens+Y
           if space1[Key].pic==Grid1 or space1[Key].pic==Grid2 then
             
            nblast.pic=Frag8
           elseif space1[Key].bg==Stone1 then
             nblast.pic=Stone1
           else 
            nblast.pic=Frag9
           end
         
           space3[#space3+1]=nblast
           space1[Key]=nil
           turrets[Key]=nil
           
         end
         Beams[Key]=100
        space1[Key]=nil
        turrets[Key]=nil
        
     end
     
   end
 end
  
 
end

  
-- -
function  block_collision(obj)
  local Key, B,xs,ys,xb,yb
  Key=tostring(math.floor(obj.x))..":"..tostring(math.floor(obj.y))
  if space1[Key]~=nil then     -- не забыть поменять на space1
    B=space1[Key]
    if B.pass_under==false then
      space1[Key].armor=space1[Key].armor-1
      if space1[Key].armor<=0 then
        if space1[Key].pic==Core1 or space1[Key].pic==Core2 then
          xb=space1[Key].x
          yb=space1[Key].y
          xs=(xb-player.x)*Dens+X
          ys=(yb-player.y)*Dens+Y
          nuclear_blast(xs,ys)
          shockwave(xb,yb,3)
          space1_check()
        end
        
        space1[Key]=nil
        
        turrets[Key]=nil
      end
      
      B=nil
      
      return true
    else
      if space1[Key].num~=nil and space1[Key].num>0 then
        local Ammo, max_Ammo, my_ammo
        if space1[Key].pic==Missile and space1[Key].num>0 then
          -- 
          if  player.weapon_type3.count<=4 then
             space1[Key].num=space1[Key].num-1
                  
             player.weapon_type3.count=player.weapon_type3.count+1
             player.weapon=3
           --torpedo_launcher={Tmax=4,count=2,I_am="torpedo",T=0,spin=0}
          end 
           --
          -- cannon={Tmax=0.3, count=100,I_am="projectile",T=0}
          
        elseif space1[Key].pic==Bomb and space1[Key].num>0 then
          if  player.weapon_type2.count<4 then
           space1[Key].num=space1[Key].num-1
                  
           player.weapon_type2.count=player.weapon_type2.count+1
           player.weapon=2
          end
          
        elseif space1[Key].pic==Star2 and space1[Key].num>0 then  
          if player.weapon_type4.count<100 then
           space1[Key].num=space1[Key].num-1
                  
           player.weapon_type4.count=player.weapon_type4.count+1
           player.weapon=4
          end
        end
        
      end
      
      B=nil
      return false
    end
  else 
    return false
  end
  
end

-- интерфейс
function control()
  local S, Ammo_count
  S=tostring(player.energy)
  S=S.sub(S,1,5)
  Graph.printf(S,730,440,40,"left")
  S=tostring(player.armor)
  S=S.sub(S,1,5)
  Graph.printf(S,730,455,40,"left")
  Graph.print("C:"..tostring(Level_cores),700,500)
  Graph.print(tostring(Level_wave_num).."/"..tostring(Level_waves),750,500)
  --
  if player.detected==true then
    Graph.draw(Diode,750,535,0)
    player.detected=false
  end
  if player.on_ray==true then
    Graph.draw(Laser_sensor,700,535,0)
    player.on_ray=false
  end
  

  --
  if player.weapon==1 then
   Graph.print("L",710,40)
   
  elseif player.weapon==2 then
    Ammo_count=tostring(player.weapon_type2.count)
   Graph.print(Ammo_count,720,130)
   --if player.weapon_type.I_am=="projectile" then 
   Graph.print("B",760,40)
   if player.weapon_type2.count>0 and player.weapon_type2.T>=player.weapon_type2.Tmax then
      Graph.print("R",755,185)
    else
      Graph.print("-",755,185)
    end
   
  elseif player.weapon==3 then
    Ammo_count=tostring(player.weapon_type3.count)
   Graph.print(Ammo_count,720,130)
    Graph.print("M",710,90)
    if player.weapon_type3.count>0 and player.weapon_type3.T>=player.weapon_type3.Tmax then
      Graph.print("R",755,185)
    else
      Graph.print("-",755,185)
    end
    
    
  elseif player.weapon==4 then
    Ammo_count=tostring(player.weapon_type4.count)
   Graph.print(Ammo_count,720,130)
    Graph.print("G",760,90)
    
  end
  
      
  if My_target~=nil and My_target~=Flash2 and JamP<8 then
    Graph.draw(My_target,60,60,My_target_angle,0.4,0.4,30,30)
    Graph.print(math.floor(T_energy),30,125)
    Graph.print(math.floor(T_armor),30,140)
  end

  if JamP<8 then
   radar()
  end
end
--рисовать помощь
function draw_help()
  local r,g,b,a,cs
  r,g,b,a=Graph.getColor()
  --Graph.setCanvas(L1) -- установить холст чтоб рисовать
  --Graph.clear()
  
  --Graph.rectangle("fill",0,0,600,400)
  --cs=math.abs(stars[1].x)/2100
  
  love.graphics.setColor(0, 0 , 0)
  love.graphics.circle("fill",X,Y, 320)
  love.graphics.setColor(0,1,0)
  Graph.print("GREEN ORBITS",X-50,50)
  Graph.print("Use your mouse to turn your ship.",X-200,70)
  Graph.print("LMB - fire, RMB - trottle, MW - change a weapon \n(Laser, Missiles, Bombs, a Gun).",X-200,90)
  
  Graph.print("Control your energy, search weapon boxes. ",X-200,120)
  Graph.print("Kill all enemies (some waves) and destroy \nall reactors to win.",X-200,140)
  Graph.print("Protect your base ship.",X-200,170)
  Graph.print("Avoid turrets.",X-200,190)
  Graph.print("Use the radar and the targeting camera to fire \na missile.",X-200,210)
  Graph.print("Press ESC to return.",X-200,240)
  
  love.graphics.setColor(r,g,b,a)

end

-- отрисовка всего 
function love.draw()
  -- local mX, mY 
  -- let's draw a background
 -- love.graphics.setColor(255,255,255,255)
  draw_stars()
  do_background()
  
  do_foreground()
 
  Graph.setCanvas() -- установить экран
  
  Graph.draw(L1,0,0) -- рисовать холст
   --Graph.stencil(myStencilFunction, "replace",2)
   --Graph.setStencilTest("notequal", 2)
  --Graph.draw(Hero,50,0)
  --Graph.draw(Hero,150,100,0)
  --Graph.draw(Hero,150,100,1)
 
  
  -- спрайт повторяется.
  --Graph.draw(Enemy,200,80)
 
  -- мышь
   
   draw_buildings()
   draw_enemies()
   draw_bullets()
   if Game_on then
     Graph.draw(Hero,X,Y,Angle,0.5,0.5,40,40)
   else
     Graph.print("No Signal...",X,Y)
   end
   
   
   
  Graph.draw(Aim,mX,mY,0,1,1,14,14)
  
  --Graph.print(tostring(math.ceil(T_energy)).."\n"..tostring(math.ceil(T_armor)),mX,mY)
  
  
  
  draw_sand()
  if Stage.T>0 then
    Graph.print(Stage.Label..tostring(Stage.num),X-Dens,Y-Dens)
  end
    
  if block_collision(player) then
    magnet_field(player.x,player.y,Angle,player.energy)
     player.x=player.x-player.speed_x/30
    player.y=player.y-player.speed_y/30
    player.speed_x= -0.8*player.speed_x
    player.speed_y= -0.8*player.speed_y
    player.energy=0.8*player.energy
    if player.energy<2 then
     player.armor=player.armor-(math.abs(player.speed_x)+math.abs(player.speed_y))/10
    end
    
  end
  
  if player['firing']==true then 
    weapon_use()
  end  
  -- love.graphics.circle("fill",400, 100, 60)
  -- love.graphics.setColor(0,255,255)
  if JamP>30 then Game_on=false end
  jamming()
  Graph.draw(L2,0,0)
  if Pause and not Show_help then
     draw_menu()
    return
  elseif Show_help then
    draw_help()
  end
  control()
  
end

